package de.intevation.flys.artifacts.math.fitting;

public class Pow
extends      Function
{
    public Pow() {
        super(
            "pow",
            "W(Q) = a*Q^c + d",
            new String [] { "a", "c", "d" });
    }

    @Override
    public double value(double x, double [] parameters) {
        return parameters[0]*Math.pow(x, parameters[1]) + parameters[2];
    }

    @Override
    public double [] gradient(double x, double [] parameters) {
        double a   = parameters[0];
        double c   = parameters[1];
        double x_c = Math.pow(x, c);
        return new double [] {
            x_c,
            a*x_c*Math.log(x),
            1d
        };
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
